!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Program Bandplot
!   7/7/00 a program to praper bandstucture plotable 
!          files from name.band file 
!  by Yonas and Natalie

Program Bandplot

  Use Crystal_data
  Use mathlib
  Use options_data
  Use paw_inout
  Use Word
  Use Strings
  Use Units

  IMPLICIT NONE

  Character*100 :: Fn, token
  Logical    :: ex
  LOGICAL    :: findA=.false.,findB=.false.,findC=.false.
  INTEGER       :: err, i , j, tlen, ier
  INTEGER       :: ifsym,ii,jj,kk,iftmp,ifcry
  integer, parameter :: input_unit=5
  integer       ::np,npanels,iargc
  REAL       ::v(3),cv(3),cdir(3),d1,d2
  REAL       ::k0(3),kf(3),dir(3),ck0(3),ckf(3)
  REAL       ::kin(3),energy,Ef
  REAL       ::shift=0.,length,calclength,Scale
  REAL, parameter :: RydtoeV=13.60569172

  if (iargc() < 1) then
     Write(*,*) 'Format: pwpaw input_file'
     STOP
  End if
  
  Call GetArg(1,Fn)
  write(*,*) 'Filename=',Fn     ! A typical pwpaw input file
  Token = Fn
  Call UpperCase(Token)
  Inquire(file=Trim(fn),exist=ex)
  if (.not.ex) then
    Write(*,*) "Can't access file ",Trim(fn)
    Write(*,*) "Make sure the file exists and has Read permissions."
    stop
  endif
  

  Call initconstants

  Write(*,*) 'Scratch_FD=',Scratch_Unit

  Call DetWordConstants(SCRATCH_UNIT)

  Call InitWord(PAW_WC, INPUT_BASE_UNIT, trim(Fn), DELIMS, COMMENT, LIT_CHAR, &
       MAX_INCLUDE, INCLUDE_STR)
  
  Call GetNextWord(PAW_WC,Token,tlen)
 
  Scale = 1

   Do 
      If (W_Error /= W_EOF ) then
         Call UpperCase(Token)

         If (Trim(Token) == "A") then
           Call GetNumbers(PAW_WC,xtal%Basis(1:3,1),3)
           findA=.true.
           write(*,*) 'A =',xtal%Basis(1:3,1)
         Else If (Trim(Token) == "B") then
           Call GetNumbers(PAW_WC,xtal%Basis(1:3,2),3)
           findB=.true.
           write(*,*) 'B =',xtal%Basis(1:3,2)
         Else If (Trim(Token) == "C") then
           Call GetNumbers(PAW_WC,xtal%Basis(1:3,3),3)
           findC=.true.
           write(*,*) 'C =',xtal%Basis(1:3,3)
         else if (Trim(token) == "SCALE") then !** Lattice scale factor     
            Call GetNumber(PAW_WC, Scale)                                       
            write(*,*) 'Scale factor =',Scale                               
         EndIf
      Else
         Exit
      EndIf
         If (findA .AND. findB .AND. findC) Exit

     Call GetNextWord(PAW_WC,Token,tlen)
    Enddo

      If (.not.findA .OR. .not.findB .OR. .not.findC) then
         write(*,*) 'Error -- Basis functions not found'
         stop
      Endif

    xtal%Basis = xtal%Basis*Scale
    xtal%Recip = RecipBasis(xtal%Basis)

    write(*,*) 'GA',xtal%Recip(:,1)
    write(*,*) 'GB',xtal%Recip(:,2)
    write(*,*) 'GC',xtal%Recip(:,3)

   WRITE(*,*) "Input file name"
   READ(*,*) Token
   OPEN(UNIT=9, FILE=trim(Token), STATUS='old', ACTION='read', IOSTAT=ier)
   IF(ier/=0)THEN
    WRITE(*,*)'ERROR in opening file'
    STOP
   END IF
   OPEN(UNIT=10, FILE=Trim(Token)//'plot', STATUS='REPLACE', ACTION='write', IOSTAT=ier)
   IF(ier/=0)THEN
    WRITE(*,*)'ERROR in opening output file'
    STOP
   END IF

   WRITE(*,*) " Note: Band energies are converted to eV "
   WRITE(*,*) " Note: k vectors should be specified in fractions of G"
   WRITE(*,*) 'Input Ef in Ry'
   READ(*,*) Ef
   WRITE(*,*)" #panels"
   READ(*,*)npanels
   panel: DO np=1,npanels
	  WRITE(*,*) "The shift value of",np," is ", shift	
   	  WRITE(*,*) "input k0 and kf respectively for panel  ",np
   	  READ(*,*)k0(1:3),kf(1:3)
  	  length=calclength(kf-k0) 
	  cdir=MAtmul(xtal%Recip,kf-k0)/length
            write(*,*) 'length = ',length, 'direction = ',cdir
		DO 
		READ(9,*,IOSTAT=ier)kin(1:3),energy
		if(ier/=0)EXIT
		write(*,*)kin(1:3),energy
                energy=energy-Ef
		v=kin(1:3)-k0(1:3)
		cv=Matmul(xtal%Recip,v)
		d1=calclength(v)
		d2=Dot_Product(cv,cdir)
	        IF(abs(d1-d2)<0.0001.AND.d1<=length+0.0001)THEN
		   write(10,'(2f12.6)')d1+shift,energy*RydtoeV
		   write(*,'(2f12.6)')d1+shift,energy*RydtoeV
		END IF
		END DO
	  shift=shift+length
                write(*,*) 'rewind',shift
		REWIND(UNIT=9)
	  END DO panel
    CLOSE(UNIT=9)
    CLOSE(UNIT=10)

      STOP
      END PROGRAM

	FUNCTION calclength (V)
		USE Crystal_data
		REAL, intent(IN) ::v(3)
		REAL ::t(3),calclength
		t=Matmul(xtal%Recip,V)
		calclength=SQRT(Dot_Product(t,t))
      		RETURN
		END
