!******************************************************************************
!
! File : basis_lib.f90
!   by : Alan Tackett
!   on : 04/29/99
!  for : PWPAW
!
!  Module containing basis specific routines
!
!******************************************************************************

Module basis_lib

IMPLICIT NONE

!******************************************************************************
Contains
!******************************************************************************

!******************************************************************************
!
!  Basis_DotProd - Perfrom a  dot product/integration
!
!     V1, V2 - Two vectors for dot product/integration
!
!******************************************************************************

Complex Function Basis_DotProd( V1, V2, DoOverlap)
   Complex, Intent(IN) :: V1(:)
   Complex, Intent(IN) :: V2(:)
   Logical,         Intent(IN) :: DoOverlap

   Basis_DotProd = DOT_PRODUCT(V1, V2)

   Return
End function


End Module
