!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  Program fixfile for plotting spin-dependent bandstructures
!     input xx.band file generated in pwpaw with
!        Calculate Band_Structure [filename] [iter] [tol]
!          keywords
!     forms separate spin up and spin down band files
program fixfile
   Real(8) :: x1,x2,x3,x4
   Logical :: spin
   integer :: i
   character(132) :: filename

   write(6,*) 'input file name (without band suffix)'
   read(5,*) filename

   open(7,file=Trim(filename)//'.band', form='formatted')
   open(300,file=Trim(filename)//'up.band', form='formatted')
   open(301,file=Trim(filename)//'dn.band', form='formatted')

   do
     read(7,*,iostat=i) x1,x2,x3,x4,spin
     if (i /= 0) exit
     if (spin) &
        write(300,'(1p3e16.7,2x,1pe16.7,l2)') x1,x2,x3,x4,spin
     if (.not.spin) &
        write(301,'(1p3e16.7,2x,1pe16.7,l2)') x1,x2,x3,x4,spin
   enddo

end program

