!******************************************************************************
!
! File : gaussfunc_data.f90
!   by : Alan Tackett
!   on : 04/25/00
!  for : 
!
!  Data structure to define the gaussian functions
!
!   N          - Number of gaussians
!   Coeff(1,:) - Shift
!   Coeff(2,:) - width or sigma
!   Coeff(3,:) - Scale factor

!
!******************************************************************************

Module gaussfunc_data
  Implicit None!!!!!!!!!

  Integer, PARAMETER :: GAUSS_SHIFT = 1
  Integer, PARAMETER :: GAUSS_SIGMA = 2
  Integer, PARAMETER :: GAUSS_SCALE = 3

  Type GaussFunc
     Integer :: N
     Real, Pointer :: Coeff(:,:)      
  End Type

End Module


