c
c $Id: group.f,v 1.1.1.1 2003/08/06 02:45:29 natalie Exp $
c
c $Log: group.f,v $
c Revision 1.1.1.1  2003/08/06 02:45:29  natalie
c PWPAW source code implemented on Osiris
c
c Revision 1.1  1992/04/21  00:43:59  alberto
c New parameter scheme
c
c Revision 1.1  1991/12/16  00:16:03  alberto
c Initial revision
c
      subroutine atftmt(nfd,a,ai,x,r,tnp,trans,ity,na,ib,ihg,ipm,li,nc,
     &                  invers_no)
c
c     subroutine atftmt determines the point group of the crystal, the
c     atom transformation table,f0, the fractional translations,tnp,
c     associated with each rotation and finally the multiplication table
c     mt, for the point group of the crystal. ib now contains
c     operations in the p.g. of the crystal and ntrans is the order of
c     this group.
c
      include 'atoms.i'
c
C     .. Scalar Arguments ..
      integer ihg, ipm, li, na, nc, invers_no, nfd
C     ..
C     .. Array Arguments ..
      Real a(3,3), ai(3,3), r(49,3,3), tnp(48,3),
     1                 trans(48,3,3), x(3,ntyp*natp)
      integer ib(48), ity(ntyp*natp)
C     ..
C     .. Local Scalars ..
      Real da, dif, eps, ts, vs
      integer i, il, is, isy, iu, j, k, k1, k2, k3, k4, ks, l, m, n, n1,
     1        n2, n3, nca, ni
C     ..
C     .. Local Arrays ..
      Real rx(3,ntyp*natp), v(3,48), vr(3), vt(3), xb(3)
      integer ia(48), ic(48), if0(48,ntyp*natp), mt(48,48)
      character cst(7)*12
C     ..
C     .. External Subroutines ..
      external rlv
C     ..
C     .. Intrinsic Functions ..
      intrinsic abs, mod
C     ..
C     .. Data statements ..
c
      data cst/'triclinic   ', 'monoclinic  ', 'orthorhombic',
     1     'tetragonal  ', 'cubic       ', 'trigonal    ',
     2     'hexagonal   '/
C     ..
      invers_no = 0
c
c     eps should be slightly larger than computer precision
c
      eps = 1.0d-8
      nca = 0
      ni = 13
      if (ihg .lt. 6) ni = 25
      li = 0
      do 130 n = 1, nc
         l = ib(n)
         ic(n) = ib(n)
         do 30 k = 1, na
            do 20 i = 1, 3
               rx(i,k) = 0.0d0
               do 10 j = 1, 3
                  rx(i,k) = rx(i,k) + r(l,i,j)*x(j,k)
   10          continue
   20       continue
   30    continue
         do 100 k1 = 1, na
            do 90 k2 = 1, na
               if (ity(k1) .eq. ity(k2)) then
                  do 40 i = 1, 3
                     xb(i) = rx(i,k1) - x(i,k2)
   40             continue
                  il = 0
                  call rlv(ai,xb,vr,il)
c           subroutine rlv removes a direct lattice vector from
c           leaving the remainder in vr. if a nonzero lattice vector was
c           removed, il is made nonzero. vr stands for v-reference.
                  ks = 0
                  do 80 k3 = 1, na
                     do 70 k4 = 1, na
                        if (ity(k3) .eq. ity(k4)) then
                           do 50 i = 1, 3
                              xb(i) = rx(i,k3) - x(i,k4)
   50                      continue
                           call rlv(ai,xb,vt,il)
c                 vt stands for v-test.
                           dif = 0.0d0
                           do 60 i = 1, 3
                              da = abs(vr(i)-vt(i)) + eps
                              dif = dif + mod(da,1.e0)
   60                      continue
                           if (dif .le. 10.0D0*eps) then
                              if0(l,k3) = k4
c                   if0 is the function defined in maradudin and vosko by
c                   eq.(2.35). it defines the atom transformation table
                              ks = ks + k4
                              if (ks .eq. na*(na+1)/2) go to 110
c
                              go to 80
c
                           end if
                        end if
   70                continue
c
                     go to 90
c
   80             continue
               end if
   90       continue
  100    continue
c
         go to 130
c
  110    continue
         nca = nca + 1
         do 120 i = 1, 3
            v(i,l) = vr(i)
  120    continue
c
c       v(i,l) is the i-th cartesian component of the fractional
c       translation associated with the rotation r(l).
c
         ib(nca) = l
         if (l .eq. ni) then
            li = l
            invers_no = nca
         endif
  130 continue
      if (ihg .eq. 7 .and. nca .eq. 24) go to 140
      if (ihg .eq. 5 .and. nca .eq. 48) go to 140
      write(nfd,9000) cst(ihg), (ic(i),i=1,nc)
 9000 format(/' The crystal system is ',a12,' with operations: ',/5x,
     1      24i3,/5x,24i3,/)
c
      go to 150
c
  140 continue
      write(nfd,9010) cst(ihg)
 9010 format(/' The point group of the crystal is the full ',a12,
     1      'group')
  150 continue
      vs = 0.0d0
      nc = nca
      do 170 n = 1, nc
         l = ib(n)
         do 160 i = 1, 3
            vs = vs + abs(v(i,l))
  160    continue
  170 continue
      if (vs .gt. eps) go to 180
      write(nfd,9020)
 9020 format(/' the space group of the crystal is symmorphic',/)
      isy = 1
      is = 1
c
      go to 190
c
  180 continue
      write(nfd,9030)
 9030 format(/,
     1    ' The space group is non-symmorphic',/,' (Or a non standard',
     2    ' origin of coordinates is used)',/)
c      ipm=1
      isy = 0
      is = 0
c
c     construct the multiplication table
c
  190 continue
      do 270 n1 = 1, nc
         do 260 n2 = 1, nc
            l = ib(n1)
            m = ib(n2)
            do 220 i = 1, 3
               do 210 j = 1, 3
                  r(49,i,j) = 0.0d0
                  do 200 k = 1, 3
                     r(49,i,j) = r(49,i,j) + r(l,i,k)*r(m,k,j)
  200             continue
  210          continue
  220       continue
            do 250 n3 = 1, nc
               n = ib(n3)
               ts = 0.0d0
               do 240 i = 1, 3
                  do 230 j = 1, 3
                     ts = ts + abs(r(49,i,j)-r(n,i,j))
  230             continue
  240          continue
               if (ts .gt. 100.0D0*eps) go to 250
               mt(l,m) = n
c
               go to 260
c
  250       continue
  260    continue
  270 continue
c
      il = 1
      iu = nc
      if (iu .gt. 24) iu = 24
  280 continue
      write(nfd,9040) (ib(i),i=il,iu)
 9040 format(' Operation number  ',24i3)
      do 300 i = 1, na
         do 290 j = 1, nc
            l = ib(j)
            ia(j) = if0(l,i)
  290    continue
  300 continue
      if (nc-iu) 320, 320, 310
  310 continue
      write(nfd,9050)
 9050 format(//)
      il = 25
      iu = nc
c
      go to 280
c
c     Print multiplication table and fractional translations.
c
  320 continue
      if (ipm .eq. 0) go to 410
      il = 1
      iu = nc
      if (nc .gt. 24) iu = 24
      if (is) 330, 330, 340
  330 continue
      write(nfd,9060)
 9060 format('0',57x,'Multiplication table',30x,
     1      'Fractional translations')
      write(nfd,9070) (ib(i),i=il,iu)
 9070 format('0',4x,24i4)
      write(nfd,9080)
 9080 format('+',107x,'v(1)      v(2)      v(3)')
c
      go to 360
c
  340 continue
      write(nfd,9090)
 9090 format('0',57x,'Multiplication table')
  350 continue
      write(nfd,9100) (ib(i),i=il,iu)
 9100 format('0',4x,24i4)
  360 continue
      do 400 j = 1, nc
         l = ib(j)
         do 370 i = il, iu
            n = ib(i)
            ia(i) = mt(l,n)
  370    continue
         if (is) 380, 380, 390
  380    continue
         write(nfd,9120) ib(j), (ia(i),i=il,iu)
         write(nfd,9110) (v(i,l),i=1,3)
 9110    format('+',102x,3f10.4)
c
         go to 400
c
  390    continue
         write(nfd,9120) ib(j), (ia(i),i=il,iu)
  400 continue
 9120 format(i5,24i4)
      if (iu .eq. nc) go to 410
      il = 25
      iu = nc
      is = 1
c
      go to 350
c
  410 continue
c
      do 440 i = 1, nc
         l = ib(i)
         do 430 j = 1, 3
            tnp(i,j) = -v(j,l)
            do 420 k = 1, 3
               trans(i,j,k) = r(l,j,k)
  420       continue
  430    continue
  440 continue
c
      return
c
      end
c
      subroutine pgl(a,b,r,nc,ib,ihg)
c
C     .. Scalar Arguments ..
      integer ihg, nc
C     ..
C     .. Array Arguments ..
      double precision a(3,3), b(3,3), r(49,3,3)
      integer ib(48)
C     ..
C     .. Local Scalars ..
      double precision eps, tr
      integer i, ihc, j, k, lx, n, nr
C     ..
C     .. Local Arrays ..
      double precision vr(3), xa(3)
C     ..
C     .. External Subroutines ..
      external rlv, rot
C     ..
C     .. Intrinsic Functions ..
      intrinsic abs
C     ..
c
c     eps should be slightly larger than computer precision
c
      eps = 1.0d-8
      ihc = 0
c
c     ihc is 0 for hexagonal groups and 1 for cubic groups.
c
      nr = 24
   10 continue
      nc = 0
      call rot(r,nr)
      do 60 n = 1, nr
         ib(n) = 0
         tr = 0.0d0
         do 50 k = 1, 3
            do 30 i = 1, 3
               xa(i) = 0.0d0
               do 20 j = 1, 3
                  xa(i) = xa(i) + r(n,i,j)*a(j,k)
   20          continue
   30       continue
            call rlv(b,xa,vr,lx)
            do 40 i = 1, 3
               tr = tr + abs(vr(i))
   40       continue
   50    continue
         if (tr .le. 10.0D0*eps) then
            nc = nc + 1
            ib(nc) = n
         end if
   60 continue
      if (ihc .eq. 0) then
         if (nc .eq. 12) then
            ihg = 6
c
            return
c
         end if
         if (nc .gt. 12) then
            ihg = 7
c
            return
c
         end if
         if (nc .lt. 12) then
            nr = 48
            ihc = 1
c
            go to 10
c
         end if
      else
         if (nc .eq. 16) then
            ihg = 4
c
            return
c
         end if
         if (nc .gt. 16) then
            ihg = 5
c
            return
c
         end if
         if (nc .lt. 16) then
            if (nc .eq. 4) then
               ihg = 2
c
               return
c
            end if
            if (nc .gt. 4) then
               ihg = 3
c
               return
c
            end if
            if (nc .lt. 4) then
               ihg = 1
c
               return
c
            end if
         end if
      end if
c
c     ihg stands for holohedral group number.
c
      end
c
      subroutine rot(r,nr)
c
C     .. Scalar Arguments ..
      integer nr
C     ..
C     .. Array Arguments ..
      double precision r(49,3,3)
C     ..
C     .. Local Scalars ..
      double precision f
      integer i, j, k, n, nv
C     ..
C     .. Intrinsic Functions ..
      intrinsic sqrt
C     ..
      do 30 n = 1, nr
         do 20 i = 1, 3
            do 10 j = 1, 3
               r(n,i,j) = 0.0d0
   10       continue
   20    continue
   30 continue
c
      if (nr .le. 24) then
c
c        define the generators for the rotation matrices
c                                 --hexagonal group
c
         f = sqrt(3.0d0)/2.0d0
         r(2,1,1) = 0.5d0
         r(2,1,2) = -f
         r(2,2,1) = f
         r(2,2,2) = 0.5d0
         r(7,1,1) = -0.5d0
         r(7,1,2) = -f
         r(7,2,1) = -f
         r(7,2,2) = 0.5d0
         do 40 n = 1, 6
            r(n,3,3) = 1.0d0
            r(n+18,3,3) = 1.0d0
            r(n+6,3,3) = -1.0d0
            r(n+12,3,3) = -1.0d0
   40    continue
c
c     generate the rest of the rotation matrices
c
         do 70 i = 1, 2
            r(1,i,i) = 1.0d0
            do 60 j = 1, 2
               r(6,i,j) = r(2,j,i)
               do 50 k = 1, 2
                  r(3,i,j) = r(3,i,j) + r(2,i,k)*r(2,k,j)
                  r(8,i,j) = r(8,i,j) + r(2,i,k)*r(7,k,j)
                  r(12,i,j) = r(12,i,j) + r(7,i,k)*r(2,k,j)
   50          continue
   60       continue
   70    continue
         do 100 i = 1, 2
            do 90 j = 1, 2
               r(5,i,j) = r(3,j,i)
               do 80 k = 1, 2
                  r(4,i,j) = r(4,i,j) + r(2,i,k)*r(3,k,j)
                  r(9,i,j) = r(9,i,j) + r(2,i,k)*r(8,k,j)
                  r(10,i,j) = r(10,i,j) + r(12,i,k)*r(3,k,j)
                  r(11,i,j) = r(11,i,j) + r(12,i,k)*r(2,k,j)
   80          continue
   90       continue
  100    continue
c
         do 130 n = 1, 12
            nv = n + 12
            do 120 i = 1, 2
               do 110 j = 1, 2
                  r(nv,i,j) = -r(n,i,j)
  110          continue
  120       continue
  130    continue
      else
c
c        define the generators for the rotation matrices
c                                          --cubic group
c
         r(9,1,3) = 1.0d0
         r(9,2,1) = 1.0d0
         r(9,3,2) = 1.0d0
         r(19,1,1) = 1.0d0
         r(19,2,3) = -1.0d0
         r(19,3,2) = 1.0d0
         do 160 i = 1, 3
            r(1,i,i) = 1.0d0
            do 150 j = 1, 3
               r(20,i,j) = r(19,j,i)
               r(5,i,j) = r(9,j,i)
               do 140 k = 1, 3
                  r(2,i,j) = r(2,i,j) + r(19,i,k)*r(19,k,j)
                  r(16,i,j) = r(16,i,j) + r(9,i,k)*r(19,k,j)
                  r(23,i,j) = r(23,i,j) + r(19,i,k)*r(9,k,j)
  140          continue
  150       continue
  160    continue
         do 190 i = 1, 3
            do 180 j = 1, 3
               do 170 k = 1, 3
                  r(6,i,j) = r(6,i,j) + r(2,i,k)*r(5,k,j)
                  r(7,i,j) = r(7,i,j) + r(16,i,k)*r(23,k,j)
                  r(8,i,j) = r(8,i,j) + r(5,i,k)*r(2,k,j)
                  r(10,i,j) = r(10,i,j) + r(2,i,k)*r(9,k,j)
                  r(11,i,j) = r(11,i,j) + r(9,i,k)*r(2,k,j)
                  r(12,i,j) = r(12,i,j) + r(23,i,k)*r(16,k,j)
                  r(14,i,j) = r(14,i,j) + r(16,i,k)*r(2,k,j)
                  r(15,i,j) = r(15,i,j) + r(2,i,k)*r(16,k,j)
                  r(22,i,j) = r(22,i,j) + r(23,i,k)*r(2,k,j)
                  r(24,i,j) = r(24,i,j) + r(2,i,k)*r(23,k,j)
  170          continue
  180       continue
  190    continue
         do 220 i = 1, 3
            do 210 j = 1, 3
               do 200 k = 1, 3
                  r(3,i,j) = r(3,i,j) + r(5,i,k)*r(12,k,j)
                  r(4,i,j) = r(4,i,j) + r(5,i,k)*r(10,k,j)
                  r(13,i,j) = r(13,i,j) + r(23,i,k)*r(11,k,j)
                  r(17,i,j) = r(17,i,j) + r(16,i,k)*r(12,k,j)
                  r(18,i,j) = r(18,i,j) + r(16,i,k)*r(10,k,j)
                  r(21,i,j) = r(21,i,j) + r(12,i,k)*r(15,k,j)
  200          continue
  210       continue
  220    continue
         do 250 n = 1, 24
            nv = n + 24
            do 240 i = 1, 3
               do 230 j = 1, 3
                  r(nv,i,j) = -r(n,i,j)
  230          continue
  240       continue
  250    continue
      end if
c
      end
c
      subroutine rlv(p,g,y,l)
c
C     .. Scalar Arguments ..
      integer l
C     ..
C     .. Array Arguments ..
      double precision g(3), p(3,3), y(3)
C     ..
C     .. Local Scalars ..
      double precision eps, ts
      integer i, j
C     ..
C     .. Local Arrays ..
      double precision del(3)
C     ..
C     .. Intrinsic Functions ..
      intrinsic abs, nint
C     ..
c
c     eps should be slightly larger than computer precision
c
      eps = 1.0d-8
      l = 0
      ts = 0.0d0
      do 10 i = 1, 3
         del(i) = 0.0d0
         y(i) = 0.0d0
         ts = ts + abs(g(i))
   10 continue
c     if (ts.le.eps) go to 40
      do 30 i = 1, 3
         do 20 j = 1, 3
            y(i) = y(i) + p(i,j)*g(j)
   20    continue
c     if (y(i).gt.0.9) del(i)=eps
c     if (y(i).lt.-0.9) del(i)=-eps
c     del is added to eliminate roundoff errors in the function amod.
c     y(i)=y(i)+del(i)
         l = l + nint(abs(y(i)))
         y(i) = y(i) - 1.0d0*nint(y(i))
c  30 y(i)=y(i)+del(i)
   30 continue
c
c   40 continue
c
      return
c
      end
c                
