!*****************************************************************************
!
! File : initatomtypes.f90
!   by : Alan Tackett
!   on : 9/21/95
!  for : PAW Project
!
! InitAtomTypes - Allocates the space for the different Atom type structures
!
!*****************************************************************************

Subroutine InitAtomTypes(WC)
  Use paw_inout
  Use atom_data
  Use misc
  
  Implicit NONE!!!!!
  Type (Word_context), Intent(INOUT) :: WC
  
  Integer :: i,j
  Character*25, Pointer :: Type_Strings(:)

  Call GetNumber(WC, j)

  if (Max_Atom_Types > 0) then  !** Ignore Already allocated **
    Write(Error_Unit, *) "InitAtomTypes: Attempt to Reallocate AtomTypes list!"
    Write(Error_Unit, *) "InitAtomTypes: Requested Size :",j
    Write(Error_Unit, *) "InitAtomTypes:   Current Size :",Max_Atom_Types
    Write(Error_Unit, *) "InitAtomTypes: Request IGNORED!"
  else if (j <= 0) then         !** Bad Value **
    Write(Error_Unit, *) "InitAtomTypes: Bad Size for AtomTypes :",j
    Write(Error_unit, *)"InitAtomTypes: IGNORING request!"
  else                          !** Good Value
    if (Print_Level <= PRINT_COMMANDS) then
       Write(Log_Unit, *) ">Max_AtomTypes ",j
    End If

    Max_Atom_Types = j
    
    Allocate(AtomType_Info(j), STAT=i)
    if (i /= 0) then         !*** Error with Allocation ***
       Write(Error_Unit, *) "InitAtomTypes: Error with Allocation! Error = ",i
       Write(Error_Unit, *) "InitAtomTypes: Requested Size : ", j
       Call Word_GetAndPrint(WC, Error_Unit, "InitAtomTypes:")
       STOP
    End If

    Allocate(Type_Strings(Max_Atom_types), STAT=i)
    Call Check_Error(i, "InitAtomTypes: Error with String LUT allocation!", &
         Error_Unit, .TRUE., WC, "InitAtomTypes:")    
    Call InitStringList(AtomType_LUT, Type_Strings, j, 0, STR_IGNORE, STR_UPPER)
  End If

  Return
End Subroutine
  
