!*****************************************************************************
!
! File : initspecificatoms.f90
!   by : Alan Tackett
!   on : 7/30/98
!  for : PAW Project
!
! InitSpecificAtoms - Allocates the space for the different 
!                     specific Atom structures
!
!*****************************************************************************

Subroutine InitSpecificAtoms(WC)
  Use paw_inout
  Use atom_data
  Use misc
  Use strings

  implicit none

  Type (Word_context), Intent(INOUT) :: WC
  
  Integer :: i,j
  Character*25, Pointer :: Type_Strings(:)

  Call GetNumber(WC, j)

  if (Max_Specific_Atoms > 0) then  !** Ignore Already allocated **
    Write(Error_Unit, *) "InitSpecificAtoms: Attempt to Reallocate ", &
                         "Specific Atoms list!"
    Write(Error_Unit, *) "InitSpecificAtoms: Requested Size :",j
    Write(Error_Unit, *) "InitSpecificAtoms:   Current Size :", &
                          Max_Specific_Atoms
    Write(Error_Unit, *) "InitSpecficiAtoms: Request IGNORED!"
  else if (j <= 0) then         !** Bad Value **
    Write(Error_Unit, *) "InitSpecificAtoms: Bad Size for Specfic Atoms :",j
    Write(Error_unit, *)"InitSpecificAtoms: IGNORING request!"
  else                          !** Good Value
    if (Print_Level <= PRINT_COMMANDS) then
       Write(Log_Unit, *) ">Max_Specific_Atoms ",j
    End If

    Max_Specific_Atoms = j
    
    Allocate(Atom_List(j), STAT=i)
    if (i /= 0) then         !*** Error with Allocation ***
       Write(Error_Unit,*) "InitSpecificAtoms: Error with Allocation! Error=",i
       Write(Error_Unit,*) "InitSpecificAtoms: Requested Size : ", j
       Call Word_GetAndPrint(WC, Error_Unit, "InitSpecificAtomss:")
       STOP
    End If

    Allocate(Type_Strings(Max_Specific_Atoms), STAT=i)
    Call Check_Error(i,"InitSpecificAtoms: Error with String LUT allocation!",&
         Error_Unit, .TRUE., WC, "InitSpecificAtoms:")    
    Call InitStringList(Atom_LUT, Type_Strings, j, 0, STR_IGNORE, STR_UPPER)
  End If

  Return
End Subroutine
  
       

