!******************************************************************************
!
! File : lrulib.f90
!   by : Alan Tackett
!   on : 04/19/1999
!  for : PW-PAW
!
!  This is a generic module implementing a Least Recently Used algorithm for
!  I/O management.
!
!******************************************************************************

Module lrulib

Use real_lru
Use complex_lru

implicit none

Interface LRU_GetRec
   Module Procedure REAL_LRU_GetRec
   Module Procedure Complex_LRU_GetRec
End Interface

Interface LRU_PutRec
   Module Procedure REAL_LRU_PutRec
   Module Procedure Complex_LRU_PutRec
End Interface
  
Interface LRU_DisplayBufferInfo
   Module Procedure REAL_LRU_DisplayBufferInfo
   Module Procedure COMPLEX_LRU_DisplayBufferInfo
End Interface

Interface LRU_FreeAll
   Module Procedure REAL_LRU_FreeAll
   Module Procedure COMPLEX_LRU_FreeAll
End Interface

Interface LRU_InitContext
   Module Procedure REAL_LRU_InitContext
   Module Procedure COMPLEX_LRU_InitContext
End Interface


End Module
