!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Program prepareballandstick
!
!   Stand-alone program to determine atomic positions and bonds
!    Calculate atomic positions and bonds for Ball and Stick model
!         (Data Explorer output and XCrysden output)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

Implicit None
 Real*8, allocatable :: ballpoints(:,:)
 Real*8 :: resx, resy, resz ,plotmat(3,3),solvmat(3,3),v(3),vin(3),vout(3)
 Real*8 :: chk,rtol,tx,ty,tz,XA,YA,ZA,A(3),B(3),C(3)
 Real*8, parameter :: atol=1.e-3
 Real*8 :: maxbond
 Integer, allocatable :: noballs(:),z(:)
 Integer :: ncount,ncountmax,many,ierr,npair,i,j,k,n,ier,specific_atoms
 Integer :: CHARGEOUT_UNIT=9
 Character*80 :: Plot_Name, Positions_Name, Readline

 write(*,*) 'Enter filename for plotting output'
 read(*,*) Plot_Name

 write(*,*) 'Enter lattice vectors A,B,C in Cartesian coordinates'
 read(*,*) A(1),A(2),A(3)
 read(*,*) B(1),B(2),B(3)
 read(*,*) C(1),C(2),C(3)
 

! file for plotting axes
  Open(unit=CHARGEOUT_UNIT,&
     file=Trim(PLOT_Name)//".cell.dx",form="formatted")
   write(CHARGEOUT_UNIT,&
    '("object 2 class array type float rank 1 shape 3 items 3 data follows")')
   write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1),A(2),A(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') B(1),B(2),B(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') C(1),C(2),C(3)
   write(CHARGEOUT_UNIT,'("attribute ""dep"" string ""positions""")')
   write(CHARGEOUT_UNIT,'("#")')
   write(CHARGEOUT_UNIT,'("end")')
   close (CHARGEOUT_UNIT)



  Open(unit=CHARGEOUT_UNIT,&
   file=Trim(PLOT_Name)//".axes.dx",form="formatted")

   write(CHARGEOUT_UNIT, &
     '("object 1 class array type float rank 0 items 8 data follows")')
   write(CHARGEOUT_UNIT,'("  1  1  1  1  1  1  1  1")')
   write(CHARGEOUT_UNIT,'("attribute ""dep"" string ""positions""")')
   write(CHARGEOUT_UNIT,'("#")')
   write(CHARGEOUT_UNIT,&
    '("object 2 class array type float rank 1 shape 3 items 8 data follows")')

   v=0
   write(CHARGEOUT_UNIT,'(1p3e15.7)') v(1:3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1),A(2),A(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1)+B(1),A(2)+B(2),A(3)+B(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') B(1),B(2),B(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') C(1),C(2),C(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1)+C(1),A(2)+C(2),A(3)+C(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1)+B(1)+C(1),A(2)+B(2)+C(2),&
           A(3)+B(3)+C(3)
   write(CHARGEOUT_UNIT,'(1p3e15.7)') B(1)+C(1),B(2)+C(2),B(3)+C(3)
 

   write(CHARGEOUT_UNIT,'("attribute ""dep"" string ""positions""")')
   write(CHARGEOUT_UNIT,'("#")')

   write(CHARGEOUT_UNIT, &
    '("object 3 class array type int rank 1 shape 2 items 12 data follows")')
   write(CHARGEOUT_UNIT, '("  0  1")')
   write(CHARGEOUT_UNIT, '("  1  2")')
   write(CHARGEOUT_UNIT, '("  2  3")')
   write(CHARGEOUT_UNIT, '("  3  0")')
   write(CHARGEOUT_UNIT, '("  4  5")')
   write(CHARGEOUT_UNIT, '("  5  6")')
   write(CHARGEOUT_UNIT, '("  6  7")')
   write(CHARGEOUT_UNIT, '("  7  4")')
   write(CHARGEOUT_UNIT, '("  0  4")')
   write(CHARGEOUT_UNIT, '("  1  5")')
   write(CHARGEOUT_UNIT, '("  2  6")')
   write(CHARGEOUT_UNIT, '("  3  7")')

   write(CHARGEOUT_UNIT,'("attribute ""element type"" string ""lines""")')
   write(CHARGEOUT_UNIT,'("attribute ""ref"" string ""positions""")')
   write(CHARGEOUT_UNIT,'("#")')
   write(CHARGEOUT_UNIT,'("object ""molecule"" class field")')
   write(CHARGEOUT_UNIT,'("component ""data"" value 1")')
   write(CHARGEOUT_UNIT,'("component ""positions"" value 2")')
   write(CHARGEOUT_UNIT,'("component ""connections"" value 3")')
   write(CHARGEOUT_UNIT,'("attribute ""name"" string ""molecule""")')
   write(CHARGEOUT_UNIT,'("#")')
   write(CHARGEOUT_UNIT,'("end")')

   close (CHARGEOUT_UNIT)

! file for atomic positions
  Open(unit=CHARGEOUT_UNIT,&
    file=Trim(PLOT_Name)//".atom.dx",form="formatted")


! Rough estimate of number atoms in plot

   write(*,*) 'datafile name containing atom positions'
   read(*,*) Positions_Name
   write(*,*) 'input maximum bond length'
   read(*,*) maxbond

    open(7,file=TRIM(Positions_Name),form="formatted")
    
    specific_atoms=0

    do
      read(7,*,iostat=ier) i
       if (ier==0) then
         specific_atoms=specific_atoms+1
       else
         exit
       endif
    enddo

    rewind(7)
      
    ncountmax=Specific_Atoms 

  Allocate(noballs(ncountmax),ballpoints(3,ncountmax),z(ncountmax))

  noballs=0
  ballpoints=0


   ncount=0


   do n=1,Specific_Atoms      ! Some assumptions here about shape of cell

       ncount=ncount+1 
       read(7,*) noballs(ncount),z(ncount),vout(:)
           ballpoints(:,ncount)=A(:)*(vout(1)+0.5d0)+B(:)*(vout(2)+0.5d0) &
               +  C(:)*(vout(3)+0.5d0)
    Enddo

!  output atomic coordinates for Data Explorer
 
    write(CHARGEOUT_UNIT, &
     '("object 1 class array type float rank 0 items",i4," data follows")') &
      ncount
    write(CHARGEOUT_UNIT,*) (noballs(i),i=1,ncount)   

    write(CHARGEOUT_UNIT,'("attribute ""dep"" string ""positions""")')
    write(CHARGEOUT_UNIT,'("#")')
    write(CHARGEOUT_UNIT,&
     '("object 2 class array type float rank 1 shape 3 items",i4," data follows")') &
      ncount

         do i=1,ncount
          write(CHARGEOUT_UNIT,*) ballpoints(1:3,i)
          enddo

        write(CHARGEOUT_UNIT,'("attribute ""dep"" string ""positions""")')
        write(CHARGEOUT_UNIT,'("#")')


         chk=maxbond**2
         npair=0  
          do i=1,ncount-1
           do j=i+1,ncount
            v=ballpoints(:,i)-ballpoints(:,j)
            if(DOT_Product(v,v).le.chk) then
            npair=npair+1
            ! write(CHARGEOUT_UNIT,*) i,j
            endif
           enddo
          enddo

   write(CHARGEOUT_UNIT, &
   '("object 3 class array type int rank 1 shape 2 items",i4," data follows")')&
   npair 
          do i=1,ncount-1
           do j=i+1,ncount
            v=ballpoints(:,i)-ballpoints(:,j)
            if(DOT_Product(v,v).le.chk) then
             write(CHARGEOUT_UNIT,*) i-1,j-1
            endif
           enddo
          enddo

         write(CHARGEOUT_UNIT,'("attribute ""element type"" string ""lines""")')
         write(CHARGEOUT_UNIT,'("attribute ""ref"" string ""positions""")')
         write(CHARGEOUT_UNIT,'("#")')
         write(CHARGEOUT_UNIT,'("object ""molecule"" class field")')
         write(CHARGEOUT_UNIT,'("component ""data"" value 1")')
         write(CHARGEOUT_UNIT,'("component ""positions"" value 2")')
         write(CHARGEOUT_UNIT,'("component ""connections"" value 3")')
         write(CHARGEOUT_UNIT,'("attribute ""name"" string ""molecule""")')
         write(CHARGEOUT_UNIT,'("#")')
         write(CHARGEOUT_UNIT,'("end")')

      Close(CHARGEOUT_UNIT)



!  XCrysDen output
  Open(unit=CHARGEOUT_UNIT,&
    file=Trim(PLOT_Name)//".xsf",form="formatted")
  Write(CHARGEOUT_UNIT,'("CRYSTAL")')
  Write(CHARGEOUT_UNIT,'("PRIMVEC   1")')
  write(CHARGEOUT_UNIT,'(1p3e15.7)') A(1:3)*0.5291772108
  write(CHARGEOUT_UNIT,'(1p3e15.7)') B(1:3)*0.5291772108
  write(CHARGEOUT_UNIT,'(1p3e15.7)') C(1:3)*0.5291772108
  Write(CHARGEOUT_UNIT,'("PRIMCOORD   1")')
  Write(CHARGEOUT_UNIT,'(i10  "   1")') ncount

     do i=1,ncount
        j=z(i)+0.0001
        write(CHARGEOUT_UNIT,'(i8,2x,1p3e15.7)') j, ballpoints(1:3,i)
     enddo



End Program    
