!***************************************************************************
!
! File : pwpaw.f90
!   by : Alan Tackett
!   on : 4/14/98
!  for : PlaneWave PAW Project
!
! This is the Driver program for the PWPAW project.
!
!***************************************************************************

Program PWPAW

  Use mathlib
  Use paw_inout
  Use Word
  Use Strings
  Use timing

  implicit none

  Type (WatchType) :: w

  Character(132) :: Fn, token
  Logical    :: ex
  Integer       :: err, i,iargc

  if (iargc() < 1) then
     Write(*,*) 'Format: pwpaw input_file'
     STOP
  End if
  
  Call GetArg(1,Fn)
  write(*,*) 'Filename=',Fn
  Token = Fn
  Call UpperCase(Token)
  Inquire(file=Trim(fn),exist=ex)
  
  if (Trim(token) == KBD_INPUT) then
     Fn = Token
!  else if (Access(trim(fn), "r") /= 0) then
   else if (.not.ex) then
     Write(*,*) "Can't access file ",Trim(fn)
     Write(*,*) "Make sure the file exists and has Read permissions."
!     
!     !DEC$ If Defined (_WIN32)
!!     Call PError("PWPAW:")
!     !DEC$ else
!     Call PError
!!     !DEC$ End If
     STOP
  End If

  Call InitTimers   !** Initialize the timers
  Call Start_Timer(Timer(Total_Timer))

  Call initconstants
  Call PAW_Init

  Print_Level = PRINT_VERBOSE

Write(*,*) 'Scratch_FD=',Scratch_Unit

  Call DetWordConstants(SCRATCH_UNIT)

  Call InitWord(PAW_WC, INPUT_BASE_UNIT, trim(Fn), DELIMS, COMMENT, LIT_CHAR, &
       MAX_INCLUDE, INCLUDE_STR)
  
  Call Read_Input(PAW_WC)

  Call PAW_End


End
