c
c $Id: rest_inv.f,v 1.1.1.1 2003/08/06 02:45:29 natalie Exp $
c
c $Log: rest_inv.f,v $
c Revision 1.1.1.1  2003/08/06 02:45:29  natalie
c PWPAW source code implemented on Osiris
c
c Revision 1.1  1992/04/21  00:43:59  alberto
c New parameter scheme
c
c Revision 1.4  1992/02/25  23:19:21  alberto
c Warn the user about the change in atomic coordinates.
c .
c
c Revision 1.3  1992/01/30  01:25:36  alberto
c Changed the inhibition mechanism to a control variable using "defined".
c
c Revision 1.2  1992/01/24  01:59:06  alberto
c Added support for inhibition via an environmental variable.
c
c Revision 1.1  1991/12/16  00:16:05  alberto
c Initial revision
c
      logical function rest_inv(n,ntype,natom,coorat,nameat)
c
      implicit none
c
      include 'atoms.i'
      include 'symmetry.h'
c
c     Restores the inversion symmetry if possible.
c     Alberto Garcia, 1990-1991
c
c     n:   Operation number associated with the inversion
c
      integer n, ntype
      integer natom(ntyp)
      real coorat(ntyp,natp,3)
      character nameat(ntyp)*2
c
      logical defined
      external defined
c
      character*60 inv_restored
      integer i, j, k
c
      inv_restored= ' Atomic coordinates changed to restore' //
     &              ' inversion symmetry'
c
      rest_inv = .FALSE.
c
c     This operation can be inhibited by defining a control
c     variable "PW_NOINVRESTOR"
c
!      if (defined('PW_NOINVRESTOR')) then
c
!        write(6,'(/,a,/)') '*** Inversion restoration inhibited ***'
c
!        return
c
!      endif
c
      if (n .le. 0) return
c
c     Check whether the inversion has a non-symmorphic translation
c
      if (max(abs(tnp(n,1)),abs(tnp(n,2)),abs(tnp(n,3))) 
     &                      .gt. 1.d-4) then
c
         Rest_Inv = .TRUE.
c
         write(6,'(/,a,//,a,//)') ' Restoring inversion symmetry...',
     &                           ' New coordinates:'
c
!**         call warnp('rest_inv',inv_restored,0,0)
c
         do 40 i = 1, ntype
            do 30 j = 1, natom(i)
              do 20 k = 1, 3
                 coorat(i,j,k) = coorat(i,j,k) - 0.5 * tnp(n,k)
   20         continue
              write(6,9030) nameat(i), j, (coorat(i,j,k),k=1,3)
 9030         format(1x,a2,' #',i2,':',3f10.6)
   30       continue
   40    continue
c
      endif
c
      write(6,'(/)')
c
      return
c
      end
